/*================================================================================
	
	-----------------------------------
	-*- [ZP] Stixsworld Zombie Classes -*-
	-----------------------------------
	
	~~~~~~~~~~~~~~~
	- Description -
	~~~~~~~~~~~~~~~
	
	This pack currently contains only 6 classes...
	
================================================================================*/

#include <amxmodx>
#include <fakemeta>
#include <zombieplague>

// Rage Zombie Attributes
new const zclass1_name[] = { "Rage Zombie" } // name
new const zclass1_info[] = { "HP+ Speed-- Jump++ Knockback+" } // description
new const zclass1_model[] = { "zombie_source" } // model
new const zclass1_clawmodel[] = { "v_knife_zombie.mdl" } // claw model
const zclass1_health = 2200 // health
const zclass1_speed = 120 // speed
const Float:zclass1_gravity = 0.50 // gravity
const Float:zclass1_knockback = 1.25 // knockback

// Bum Zombie Attributes
new const zclass2_name[] = { "Bum Zombie" } // name
new const zclass2_info[] = { "HP++ Jump-- Knockback++" } // description
new const zclass2_model[] = { "zombie_source" } // model
new const zclass2_clawmodel[] = { "v_knife_zombie.mdl" } // claw model
const zclass2_health = 2600 // health
const zclass2_speed = 190 // speed
const Float:zclass2_gravity = 1.50 // gravity
const Float:zclass2_knockback = 1.5 // knockback

// Ex-Assasin Zombie Attributes
new const zclass3_name[] = { "Ex-Assasin Zombie" } // name
new const zclass3_info[] = { "HP-- Speed++ Jump++ Knockback-" } // description
new const zclass3_model[] = { "zombie_source" } // model
new const zclass3_clawmodel[] = { "v_knife_zombie.mdl" } // claw model
const zclass3_health = 900 // health
const zclass3_speed = 225 // speed
const Float:zclass3_gravity = 0.50 // gravity
const Float:zclass3_knockback = 0.75 // knockback

// Invincible Zombie Attributes
new const zclass4_name[] = { "Invincible Zombie" } // name
new const zclass4_info[] = { "HP+++ Speed-- Jump- Knockback----" } // description
new const zclass4_model[] = { "zombie_source" } // model
new const zclass4_clawmodel[] = { "v_knife_zombie.mdl" } // claw model
const zclass4_health = 3000 // health
const zclass4_speed = 120 // speed
const Float:zclass4_gravity = 1.25 // gravity
const Float:zclass4_knockback = 0.0 // knockback

// Demonic Zombie Attributes
new const zclass5_name[] = { "Demonic Zombie" } // name
new const zclass5_info[] = { "HP+++ Speed++ Jump++ Knockback---" } // description
new const zclass5_model[] = { "zombie_source" } // model
new const zclass5_clawmodel[] = { "v_knife_zombie.mdl" } // claw model
const zclass5_health = 3000 // health
const zclass5_speed = 225 // speed
const Float:zclass5_gravity = 0.50 // gravity
const Float:zclass5_knockback = 0.25 // knockback

// Lucy Zombie Attributes
new const zclass6_name[] = { "Lucy Zombie" } // name
new const zclass6_info[] = { "Speed- Jump+ Leech+" } // description
new const zclass6_model[] = { "zombie_source" } // model
new const zclass6_clawmodel[] = { "v_knife_zombie.mdl" } // claw model
const zclass6_health = 1800 // health
const zclass6_speed = 155 // speed
const Float:zclass6_gravity = 0.75 // gravity
const Float:zclass6_knockback = 1.0 // knockback
const zclass6_infecthp = 100 // extra hp for infections

// Class IDs
new g_zclass_leech

// Zombie Classes MUST be registered on plugin_precache
public plugin_precache()
{
	register_plugin("[ZP] Stixsworld Zombie Classes", "1.4a", "www.stixsworld.com/Stixsmaster")
	
	// Register the new class and store ID for reference
	zp_register_zombie_class(zclass1_name, zclass1_info, zclass1_model, zclass1_clawmodel, zclass1_health, zclass1_speed, zclass1_gravity, zclass1_knockback)
	zp_register_zombie_class(zclass2_name, zclass2_info, zclass2_model, zclass2_clawmodel, zclass2_health, zclass2_speed, zclass2_gravity, zclass2_knockback)
	zp_register_zombie_class(zclass3_name, zclass3_info, zclass3_model, zclass3_clawmodel, zclass3_health, zclass3_speed, zclass3_gravity, zclass3_knockback)
	zp_register_zombie_class(zclass4_name, zclass4_info, zclass4_model, zclass4_clawmodel, zclass4_health, zclass4_speed, zclass4_gravity, zclass4_knockback)
	zp_register_zombie_class(zclass5_name, zclass5_info, zclass5_model, zclass5_clawmodel, zclass5_health, zclass5_speed, zclass5_gravity, zclass5_knockback)
	g_zclass_leech = zp_register_zombie_class(zclass6_name, zclass6_info, zclass6_model, zclass6_clawmodel, zclass6_health, zclass6_speed, zclass6_gravity, zclass6_knockback)
}

// User Infected forward
public zp_user_infected_post(id, infector)
{
	// If attacker is a leech zombie, gets extra hp
	if (zp_get_user_zombie_class(infector) == g_zclass_leech)
		set_pev(infector, pev_health, float(pev(infector, pev_health) + zclass6_infecthp))
}
